org.objectweb.asm.xml

## Class SAXCodeAdapter

- java.lang.Object
- - org.objectweb.asm.MethodVisitor
  - - org.objectweb.asm.xml.SAXCodeAdapter

-     public final class SAXCodeAdapter
      extends MethodVisitor

  A `MethodVisitor` that generates SAX 2.0 events from the visited method.
  Author:
    Eugene Kuleshov
  See Also:
    `SAXClassAdapter`, `Processor`

- - ### Field Summary

    - ### Fields inherited from class org.objectweb.asm.MethodVisitor

      `api, mv`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SAXCodeAdapter(SAXAdapter sa, int access)` Constructs a new `SAXCodeAdapter` object.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `AnnotationVisitor` | `visitAnnotation(String desc, boolean visible)` Visits an annotation of this method.
    `AnnotationVisitor` | `visitAnnotationDefault()` Visits the default value of this annotation interface method.
    `void` | `visitCode()` Starts the visit of the method's code, if any (i.e. non abstract method).
    `void` | `visitEnd()` Visits the end of the method.
    `void` | `visitFieldInsn(int opcode, String owner, String name, String desc)` Visits a field instruction.
    `void` | `visitFrame(int type, int nLocal, Object[] local, int nStack, Object[] stack)` Visits the current state of the local variables and operand stack elements.
    `void` | `visitIincInsn(int var, int increment)` Visits an IINC instruction.
    `void` | `visitInsn(int opcode)` Visits a zero operand instruction.
    `AnnotationVisitor` | `visitInsnAnnotation(int typeRef, TypePath typePath, String desc, boolean visible)` Visits an annotation on an instruction.
    `void` | `visitIntInsn(int opcode, int operand)` Visits an instruction with a single int operand.
    `void` | `visitInvokeDynamicInsn(String name, String desc, Handle bsm, Object... bsmArgs)` Visits an invokedynamic instruction.
    `void` | `visitJumpInsn(int opcode, Label label)` Visits a jump instruction.
    `void` | `visitLabel(Label label)` Visits a label.
    `void` | `visitLdcInsn(Object cst)` Visits a LDC instruction.
    `void` | `visitLineNumber(int line, Label start)` Visits a line number declaration.
    `void` | `visitLocalVariable(String name, String desc, String signature, Label start, Label end, int index)` Visits a local variable declaration.
    `AnnotationVisitor` | `visitLocalVariableAnnotation(int typeRef, TypePath typePath, Label[] start, Label[] end, int[] index, String desc, boolean visible)` Visits an annotation on a local variable type.
    `void` | `visitLookupSwitchInsn(Label dflt, int[] keys, Label[] labels)` Visits a LOOKUPSWITCH instruction.
    `void` | `visitMaxs(int maxStack, int maxLocals)` Visits the maximum stack size and the maximum number of local variables of the method.
    `void` | `visitMethodInsn(int opcode, String owner, String name, String desc, boolean itf)` Visits a method instruction.
    `void` | `visitMultiANewArrayInsn(String desc, int dims)` Visits a MULTIANEWARRAY instruction.
    `void` | `visitParameter(String name, int access)` Visits a parameter of this method.
    `AnnotationVisitor` | `visitParameterAnnotation(int parameter, String desc, boolean visible)` Visits an annotation of a parameter this method.
    `void` | `visitTableSwitchInsn(int min, int max, Label dflt, Label... labels)` Visits a TABLESWITCH instruction.
    `AnnotationVisitor` | `visitTryCatchAnnotation(int typeRef, TypePath typePath, String desc, boolean visible)` Visits an annotation on an exception handler type.
    `void` | `visitTryCatchBlock(Label start, Label end, Label handler, String type)` Visits a try catch block.
    `AnnotationVisitor` | `visitTypeAnnotation(int typeRef, TypePath typePath, String desc, boolean visible)` Visits an annotation on a type in the method signature.
    `void` | `visitTypeInsn(int opcode, String type)` Visits a type instruction.
    `void` | `visitVarInsn(int opcode, int var)` Visits a local variable instruction.

    - ### Methods inherited from class org.objectweb.asm.MethodVisitor

      `visitAttribute, visitMethodInsn`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SAXCodeAdapter

          public SAXCodeAdapter(SAXAdapter sa,
                                int access)

      Constructs a new `SAXCodeAdapter` object.
      Parameters:
        `sa` - content handler that will be used to send SAX 2.0 events.

  - ### Method Detail

    - #### visitParameter

          public void visitParameter(String name,
                                     int access)

      Description copied from class: `MethodVisitor`
      Visits a parameter of this method.
      Overrides:
        `visitParameter` in class `MethodVisitor`
      Parameters:
        `name` - parameter name or null if none is provided.
        `access` - the parameter's access flags, only `ACC_FINAL`, `ACC_SYNTHETIC` or/and `ACC_MANDATED` are allowed (see `Opcodes`).

    - #### visitCode

          public final void visitCode()

      Description copied from class: `MethodVisitor`
      Starts the visit of the method's code, if any (i.e. non abstract method).
      Overrides:
        `visitCode` in class `MethodVisitor`

    - #### visitFrame

          public void visitFrame(int type,
                                 int nLocal,
                                 Object[] local,
                                 int nStack,
                                 Object[] stack)

      Description copied from class: `MethodVisitor`
      Visits the current state of the local variables and operand stack elements. This method must(*) be called just before any instruction i that follows an unconditional branch instruction such as GOTO or THROW, that is the target of a jump instruction, or that starts an exception handler block. The visited types must describe the values of the local variables and of the operand stack elements just before i is executed.
      (*) this is mandatory only for classes whose version is greater than or equal to `V1_6`.
      The frames of a method must be given either in expanded form, or in compressed form (all frames must use the same format, i.e. you must not mix expanded and compressed frames within a single method):
      - In expanded form, all frames must have the F_NEW type.
      - In compressed form, frames are basically "deltas" from the state of the previous frame:
        - `Opcodes.F_SAME` representing frame with exactly the same locals as the previous frame and with the empty stack.
        - `Opcodes.F_SAME1` representing frame with exactly the same locals as the previous frame and with single value on the stack ( `nStack` is 1 and `stack[0]` contains value for the type of the stack item).
        - `Opcodes.F_APPEND` representing frame with current locals are the same as the locals in the previous frame, except that additional locals are defined (`nLocal` is 1, 2 or 3 and `local` elements contains values representing added types).
        - `Opcodes.F_CHOP` representing frame with current locals are the same as the locals in the previous frame, except that the last 1-3 locals are absent and with the empty stack (`nLocals` is 1, 2 or 3).
        - `Opcodes.F_FULL` representing complete frame data.
      In both cases the first frame, corresponding to the method's parameters and access flags, is implicit and must not be visited. Also, it is illegal to visit two or more frames for the same code location (i.e., at least one instruction must be visited between two calls to visitFrame).
      Overrides:
        `visitFrame` in class `MethodVisitor`
      Parameters:
        `type` - the type of this stack map frame. Must be `Opcodes.F_NEW` for expanded frames, or `Opcodes.F_FULL`, `Opcodes.F_APPEND`, `Opcodes.F_CHOP`, `Opcodes.F_SAME` or `Opcodes.F_APPEND`, `Opcodes.F_SAME1` for compressed frames.
        `nLocal` - the number of local variables in the visited frame.
        `local` - the local variable types in this frame. This array must not be modified. Primitive types are represented by `Opcodes.TOP`, `Opcodes.INTEGER`, `Opcodes.FLOAT`, `Opcodes.LONG`, `Opcodes.DOUBLE`,`Opcodes.NULL` or `Opcodes.UNINITIALIZED_THIS` (long and double are represented by a single element). Reference types are represented by String objects (representing internal names), and uninitialized types by Label objects (this label designates the NEW instruction that created this uninitialized value).
        `nStack` - the number of operand stack elements in the visited frame.
        `stack` - the operand stack types in this frame. This array must not be modified. Its content has the same format as the "local" array.

    - #### visitInsn

          public final void visitInsn(int opcode)

      Description copied from class: `MethodVisitor`
      Visits a zero operand instruction.
      Overrides:
        `visitInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the instruction to be visited. This opcode is either NOP, ACONST_NULL, ICONST_M1, ICONST_0, ICONST_1, ICONST_2, ICONST_3, ICONST_4, ICONST_5, LCONST_0, LCONST_1, FCONST_0, FCONST_1, FCONST_2, DCONST_0, DCONST_1, IALOAD, LALOAD, FALOAD, DALOAD, AALOAD, BALOAD, CALOAD, SALOAD, IASTORE, LASTORE, FASTORE, DASTORE, AASTORE, BASTORE, CASTORE, SASTORE, POP, POP2, DUP, DUP_X1, DUP_X2, DUP2, DUP2_X1, DUP2_X2, SWAP, IADD, LADD, FADD, DADD, ISUB, LSUB, FSUB, DSUB, IMUL, LMUL, FMUL, DMUL, IDIV, LDIV, FDIV, DDIV, IREM, LREM, FREM, DREM, INEG, LNEG, FNEG, DNEG, ISHL, LSHL, ISHR, LSHR, IUSHR, LUSHR, IAND, LAND, IOR, LOR, IXOR, LXOR, I2L, I2F, I2D, L2I, L2F, L2D, F2I, F2L, F2D, D2I, D2L, D2F, I2B, I2C, I2S, LCMP, FCMPL, FCMPG, DCMPL, DCMPG, IRETURN, LRETURN, FRETURN, DRETURN, ARETURN, RETURN, ARRAYLENGTH, ATHROW, MONITORENTER, or MONITOREXIT.

    - #### visitIntInsn

          public final void visitIntInsn(int opcode,
                                         int operand)

      Description copied from class: `MethodVisitor`
      Visits an instruction with a single int operand.
      Overrides:
        `visitIntInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the instruction to be visited. This opcode is either BIPUSH, SIPUSH or NEWARRAY.
        `operand` - the operand of the instruction to be visited.
        When opcode is BIPUSH, operand value should be between Byte.MIN_VALUE and Byte.MAX_VALUE.
        When opcode is SIPUSH, operand value should be between Short.MIN_VALUE and Short.MAX_VALUE.
        When opcode is NEWARRAY, operand value should be one of `Opcodes.T_BOOLEAN`, `Opcodes.T_CHAR`, `Opcodes.T_FLOAT`, `Opcodes.T_DOUBLE`, `Opcodes.T_BYTE`, `Opcodes.T_SHORT`, `Opcodes.T_INT` or `Opcodes.T_LONG`.

    - #### visitVarInsn

          public final void visitVarInsn(int opcode,
                                         int var)

      Description copied from class: `MethodVisitor`
      Visits a local variable instruction. A local variable instruction is an instruction that loads or stores the value of a local variable.
      Overrides:
        `visitVarInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the local variable instruction to be visited. This opcode is either ILOAD, LLOAD, FLOAD, DLOAD, ALOAD, ISTORE, LSTORE, FSTORE, DSTORE, ASTORE or RET.
        `var` - the operand of the instruction to be visited. This operand is the index of a local variable.

    - #### visitTypeInsn

          public final void visitTypeInsn(int opcode,
                                          String type)

      Description copied from class: `MethodVisitor`
      Visits a type instruction. A type instruction is an instruction that takes the internal name of a class as parameter.
      Overrides:
        `visitTypeInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either NEW, ANEWARRAY, CHECKCAST or INSTANCEOF.
        `type` - the operand of the instruction to be visited. This operand must be the internal name of an object or array class (see `getInternalName`).

    - #### visitFieldInsn

          public final void visitFieldInsn(int opcode,
                                           String owner,
                                           String name,
                                           String desc)

      Description copied from class: `MethodVisitor`
      Visits a field instruction. A field instruction is an instruction that loads or stores the value of a field of an object.
      Overrides:
        `visitFieldInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either GETSTATIC, PUTSTATIC, GETFIELD or PUTFIELD.
        `owner` - the internal name of the field's owner class (see `getInternalName`).
        `name` - the field's name.
        `desc` - the field's descriptor (see `Type`).

    - #### visitMethodInsn

          public final void visitMethodInsn(int opcode,
                                            String owner,
                                            String name,
                                            String desc,
                                            boolean itf)

      Description copied from class: `MethodVisitor`
      Visits a method instruction. A method instruction is an instruction that invokes a method.
      Overrides:
        `visitMethodInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either INVOKEVIRTUAL, INVOKESPECIAL, INVOKESTATIC or INVOKEINTERFACE.
        `owner` - the internal name of the method's owner class (see `getInternalName`).
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).
        `itf` - if the method's owner class is an interface.

    - #### visitInvokeDynamicInsn

          public void visitInvokeDynamicInsn(String name,
                                             String desc,
                                             Handle bsm,
                                             Object... bsmArgs)

      Description copied from class: `MethodVisitor`
      Visits an invokedynamic instruction.
      Overrides:
        `visitInvokeDynamicInsn` in class `MethodVisitor`
      Parameters:
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).
        `bsm` - the bootstrap method.
        `bsmArgs` - the bootstrap method constant arguments. Each argument must be an `Integer`, `Float`, `Long`, `Double`, `String`, `Type` or `Handle` value. This method is allowed to modify the content of the array so a caller should expect that this array may change.

    - #### visitJumpInsn

          public final void visitJumpInsn(int opcode,
                                          Label label)

      Description copied from class: `MethodVisitor`
      Visits a jump instruction. A jump instruction is an instruction that may jump to another instruction.
      Overrides:
        `visitJumpInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either IFEQ, IFNE, IFLT, IFGE, IFGT, IFLE, IF_ICMPEQ, IF_ICMPNE, IF_ICMPLT, IF_ICMPGE, IF_ICMPGT, IF_ICMPLE, IF_ACMPEQ, IF_ACMPNE, GOTO, JSR, IFNULL or IFNONNULL.
        `label` - the operand of the instruction to be visited. This operand is a label that designates the instruction to which the jump instruction may jump.

    - #### visitLabel

          public final void visitLabel(Label label)

      Description copied from class: `MethodVisitor`
      Visits a label. A label designates the instruction that will be visited just after it.
      Overrides:
        `visitLabel` in class `MethodVisitor`
      Parameters:
        `label` - a `Label` object.

    - #### visitLdcInsn

          public final void visitLdcInsn(Object cst)

      Description copied from class: `MethodVisitor`
      Visits a LDC instruction. Note that new constant types may be added in future versions of the Java Virtual Machine. To easily detect new constant types, implementations of this method should check for unexpected constant types, like this:

           if (cst instanceof Integer) {
               // ...
           } else if (cst instanceof Float) {
               // ...
           } else if (cst instanceof Long) {
               // ...
           } else if (cst instanceof Double) {
               // ...
           } else if (cst instanceof String) {
               // ...
           } else if (cst instanceof Type) {
               int sort = ((Type) cst).getSort();
               if (sort == Type.OBJECT) {
                   // ...
               } else if (sort == Type.ARRAY) {
                   // ...
               } else if (sort == Type.METHOD) {
                   // ...
               } else {
                   // throw an exception
               }
           } else if (cst instanceof Handle) {
               // ...
           } else {
               // throw an exception
           }

      Overrides:
        `visitLdcInsn` in class `MethodVisitor`
      Parameters:
        `cst` - the constant to be loaded on the stack. This parameter must be a non null `Integer`, a `Float`, a `Long`, a `Double`, a `String`, a `Type` of OBJECT or ARRAY sort for `.class` constants, for classes whose version is 49.0, a `Type` of METHOD sort or a `Handle` for MethodType and MethodHandle constants, for classes whose version is 51.0.

    - #### visitIincInsn

          public final void visitIincInsn(int var,
                                          int increment)

      Description copied from class: `MethodVisitor`
      Visits an IINC instruction.
      Overrides:
        `visitIincInsn` in class `MethodVisitor`
      Parameters:
        `var` - index of the local variable to be incremented.
        `increment` - amount to increment the local variable by.

    - #### visitTableSwitchInsn

          public final void visitTableSwitchInsn(int min,
                                                 int max,
                                                 Label dflt,
                                                 Label... labels)

      Description copied from class: `MethodVisitor`
      Visits a TABLESWITCH instruction.
      Overrides:
        `visitTableSwitchInsn` in class `MethodVisitor`
      Parameters:
        `min` - the minimum key value.
        `max` - the maximum key value.
        `dflt` - beginning of the default handler block.
        `labels` - beginnings of the handler blocks. `labels[i]` is the beginning of the handler block for the `min + i` key.

    - #### visitLookupSwitchInsn

          public final void visitLookupSwitchInsn(Label dflt,
                                                  int[] keys,
                                                  Label[] labels)

      Description copied from class: `MethodVisitor`
      Visits a LOOKUPSWITCH instruction.
      Overrides:
        `visitLookupSwitchInsn` in class `MethodVisitor`
      Parameters:
        `dflt` - beginning of the default handler block.
        `keys` - the values of the keys.
        `labels` - beginnings of the handler blocks. `labels[i]` is the beginning of the handler block for the `keys[i]` key.

    - #### visitMultiANewArrayInsn

          public final void visitMultiANewArrayInsn(String desc,
                                                    int dims)

      Description copied from class: `MethodVisitor`
      Visits a MULTIANEWARRAY instruction.
      Overrides:
        `visitMultiANewArrayInsn` in class `MethodVisitor`
      Parameters:
        `desc` - an array type descriptor (see `Type`).
        `dims` - number of dimensions of the array to allocate.

    - #### visitTryCatchBlock

          public final void visitTryCatchBlock(Label start,
                                               Label end,
                                               Label handler,
                                               String type)

      Description copied from class: `MethodVisitor`
      Visits a try catch block.
      Overrides:
        `visitTryCatchBlock` in class `MethodVisitor`
      Parameters:
        `start` - beginning of the exception handler's scope (inclusive).
        `end` - end of the exception handler's scope (exclusive).
        `handler` - beginning of the exception handler's code.
        `type` - internal name of the type of exceptions handled by the handler, or `null` to catch any exceptions (for "finally" blocks).

    - #### visitMaxs

          public final void visitMaxs(int maxStack,
                                      int maxLocals)

      Description copied from class: `MethodVisitor`
      Visits the maximum stack size and the maximum number of local variables of the method.
      Overrides:
        `visitMaxs` in class `MethodVisitor`
      Parameters:
        `maxStack` - maximum stack size of the method.
        `maxLocals` - maximum number of local variables for the method.

    - #### visitLocalVariable

          public void visitLocalVariable(String name,
                                         String desc,
                                         String signature,
                                         Label start,
                                         Label end,
                                         int index)

      Description copied from class: `MethodVisitor`
      Visits a local variable declaration.
      Overrides:
        `visitLocalVariable` in class `MethodVisitor`
      Parameters:
        `name` - the name of a local variable.
        `desc` - the type descriptor of this local variable.
        `signature` - the type signature of this local variable. May be `null` if the local variable type does not use generic types.
        `start` - the first instruction corresponding to the scope of this local variable (inclusive).
        `end` - the last instruction corresponding to the scope of this local variable (exclusive).
        `index` - the local variable's index.

    - #### visitLineNumber

          public final void visitLineNumber(int line,
                                            Label start)

      Description copied from class: `MethodVisitor`
      Visits a line number declaration.
      Overrides:
        `visitLineNumber` in class `MethodVisitor`
      Parameters:
        `line` - a line number. This number refers to the source file from which the class was compiled.
        `start` - the first instruction corresponding to this line number.

    - #### visitAnnotationDefault

          public AnnotationVisitor visitAnnotationDefault()

      Description copied from class: `MethodVisitor`
      Visits the default value of this annotation interface method.
      Overrides:
        `visitAnnotationDefault` in class `MethodVisitor`
      Returns:
        a visitor to the visit the actual default value of this annotation interface method, or `null` if this visitor is not interested in visiting this default value. The 'name' parameters passed to the methods of this annotation visitor are ignored. Moreover, exacly one visit method must be called on this annotation visitor, followed by visitEnd.

    - #### visitAnnotation

          public AnnotationVisitor visitAnnotation(String desc,
                                                   boolean visible)

      Description copied from class: `MethodVisitor`
      Visits an annotation of this method.
      Overrides:
        `visitAnnotation` in class `MethodVisitor`
      Parameters:
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitTypeAnnotation

          public AnnotationVisitor visitTypeAnnotation(int typeRef,
                                                       TypePath typePath,
                                                       String desc,
                                                       boolean visible)

      Description copied from class: `MethodVisitor`
      Visits an annotation on a type in the method signature.
      Overrides:
        `visitTypeAnnotation` in class `MethodVisitor`
      Parameters:
        `typeRef` - a reference to the annotated type. The sort of this type reference must be `METHOD_TYPE_PARAMETER`, `METHOD_TYPE_PARAMETER_BOUND`, `METHOD_RETURN`, `METHOD_RECEIVER`, `METHOD_FORMAL_PARAMETER` or `THROWS`. See `TypeReference`.
        `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be `null` if the annotation targets 'typeRef' as a whole.
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitParameterAnnotation

          public AnnotationVisitor visitParameterAnnotation(int parameter,
                                                            String desc,
                                                            boolean visible)

      Description copied from class: `MethodVisitor`
      Visits an annotation of a parameter this method.
      Overrides:
        `visitParameterAnnotation` in class `MethodVisitor`
      Parameters:
        `parameter` - the parameter index.
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitInsnAnnotation

          public AnnotationVisitor visitInsnAnnotation(int typeRef,
                                                       TypePath typePath,
                                                       String desc,
                                                       boolean visible)

      Description copied from class: `MethodVisitor`
      Visits an annotation on an instruction. This method must be called just after the annotated instruction. It can be called several times for the same instruction.
      Overrides:
        `visitInsnAnnotation` in class `MethodVisitor`
      Parameters:
        `typeRef` - a reference to the annotated type. The sort of this type reference must be `INSTANCEOF`, `NEW`, `CONSTRUCTOR_REFERENCE`, `METHOD_REFERENCE`, `CAST`, `CONSTRUCTOR_INVOCATION_TYPE_ARGUMENT`, `METHOD_INVOCATION_TYPE_ARGUMENT`, `CONSTRUCTOR_REFERENCE_TYPE_ARGUMENT`, or `METHOD_REFERENCE_TYPE_ARGUMENT`. See `TypeReference`.
        `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be `null` if the annotation targets 'typeRef' as a whole.
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitTryCatchAnnotation

          public AnnotationVisitor visitTryCatchAnnotation(int typeRef,
                                                           TypePath typePath,
                                                           String desc,
                                                           boolean visible)

      Description copied from class: `MethodVisitor`
      Visits an annotation on an exception handler type. This method must be called after the `MethodVisitor.visitTryCatchBlock(org.objectweb.asm.Label, org.objectweb.asm.Label, org.objectweb.asm.Label, java.lang.String)` for the annotated exception handler. It can be called several times for the same exception handler.
      Overrides:
        `visitTryCatchAnnotation` in class `MethodVisitor`
      Parameters:
        `typeRef` - a reference to the annotated type. The sort of this type reference must be `EXCEPTION_PARAMETER`. See `TypeReference`.
        `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be `null` if the annotation targets 'typeRef' as a whole.
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitLocalVariableAnnotation

          public AnnotationVisitor visitLocalVariableAnnotation(int typeRef,
                                                                TypePath typePath,
                                                                Label[] start,
                                                                Label[] end,
                                                                int[] index,
                                                                String desc,
                                                                boolean visible)

      Description copied from class: `MethodVisitor`
      Visits an annotation on a local variable type.
      Overrides:
        `visitLocalVariableAnnotation` in class `MethodVisitor`
      Parameters:
        `typeRef` - a reference to the annotated type. The sort of this type reference must be `LOCAL_VARIABLE` or `RESOURCE_VARIABLE`. See `TypeReference`.
        `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be `null` if the annotation targets 'typeRef' as a whole.
        `start` - the fist instructions corresponding to the continuous ranges that make the scope of this local variable (inclusive).
        `end` - the last instructions corresponding to the continuous ranges that make the scope of this local variable (exclusive). This array must have the same size as the 'start' array.
        `index` - the local variable's index in each range. This array must have the same size as the 'start' array.
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitEnd

          public void visitEnd()

      Description copied from class: `MethodVisitor`
      Visits the end of the method. This method, which is the last one to be called, is used to inform the visitor that all the annotations and attributes of the method have been visited.
      Overrides:
        `visitEnd` in class `MethodVisitor`